=== debian/changelog ===
alkimia (8.1.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unnecessary Build-Depends: libqt5webkit5-dev. (Closes: #1098334)

 -- Bastian Germann <bage@debian.org>  Wed, 19 Feb 2025 12:20:52 +0100

alkimia (8.1.2-2) unstable; urgency=medium

  * Team upload.
  * Update symbols file from the logs of buildds.
  * Drop also the not useful README files in installed data files
    - ship the README for plasma-widget-foreigncurrencies from the sources,
      instead of relying on it being installed
  * Switch the cmake parameter -DCMAKE_DISABLE_FIND_PACKAGE_MPIR=OFF to
    -DCMAKE_DISABLE_FIND_PACKAGE_MPIR=ON to actually disable the search of MPIR;
    GMP is wanted instead.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Oct 2023 08:00:21 +0200

alkimia (8.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update the upstream GPG signing key.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16.0
  * Drop LICENSE files after the installation to debian/tmp; this way there is
    no need for extra steps to avoid them in install files:
    - simplify debian/plasma-widget-foreigncurrencies.install, shipping the
      whole directory of the plasmoid
    - drop debian/not-installed, no more needed

 -- Pino Toscano <pino@debian.org>  Wed, 06 Sep 2023 00:58:50 +0200
